#ifndef APP_H_
#define APP_H_

#include "gmath/gmath.h"

extern int win_width, win_height;
extern float win_aspect;
extern long time_msec;

extern Mat4 view_matrix;


bool app_init(int argc, char **argv);
void app_cleanup();

void app_draw();
void app_reshape(int x, int y);
void app_keyboard(int key, bool pressed);
void app_mouse_button(int bn, bool pressed, int x, int y);
void app_mouse_motion(int x, int y);

// the following functions are implemented by the window system backend
void app_quit();
void app_redraw();
void app_swap_buffers();
long app_get_msec();

#endif	// APP_H_
